package INSTALL::reboot;

use INSTALL::common;
use INSTALL::global;
use INSTALL::os;
use INSTALL::substitute;

my $pOS = \%INSTALL::os::Details;

my $pGlobals = \%INSTALL::global::variables;

# These aren't my'd because they need to be resolved symbolically in code
# below.  my'd symbols cannot be resolved symbolically.

$RedHat_RCFile =
'#!/bin/sh
#------------------------------------------------------------------------------
# Generated for Chili!Soft ASP Server
#
# Author: Chili!Soft, Inc. (2000)
# Script: <<reboot::script_name>>
#------------------------------------------------------------------------------

# Source function library.
. /etc/rc.d/init.d/functions

# See how we were called.
case "$1" in
  start)
        echo -n "Executing start script (<<reboot::script_name>>): "
	<<reboot::start_script>> > /dev/null 2>&1 && success || failed $1
        echo
        touch /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
  stop)
        echo -n "Executing stop script (<<reboot::script_name>>): "
	<<reboot::stop_script>> > /dev/null 2>&1 && success || failed $1
        echo
        rm -f /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
  status)
        echo "Executing status script(<<reboot::script_name>>): "
	<<reboot::status_script>>
        ;;
  restart)
        $0 stop
        $0 start
        ;;
  *)
        echo "Usage: $0 {start|stop|restart|status}"
        exit 1
esac

exit 0
';

$TurboLinux_RCFile =
'#!/bin/sh
#------------------------------------------------------------------------------
# Generated for Chili!Soft ASP Server
#
# Author: Chili!Soft, Inc. (2000)
# Script: <<reboot::script_name>>
#------------------------------------------------------------------------------

# Source function library.
. /etc/rc.d/init.d/functions

function success
{
  echo -n "Success."
}

function failure
{
  echo "Failed to $1."
  exit 1
}

# See how we were called.
case "$1" in
  start)
        echo -n "Executing start script (<<reboot::script_name>>): "
	<<reboot::start_script>> > /dev/null 2>&1 && success || failed $1
        echo
        touch /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
  stop)
        echo -n "Executing stop script (<<reboot::script_name>>): "
	<<reboot::stop_script>> > /dev/null 2>&1 && success || failed $1
        echo
        rm -f /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
  status)
        echo "Executing status script(<<reboot::script_name>>): "
	<<reboot::status_script>>
        ;;
  restart)
        $0 stop
        $0 start
        ;;
  *)
        echo "Usage: $0 {start|stop|restart|status}"
        exit 1
esac

exit 0
';

$SuSE_RCFile =
'#! /bin/sh
#------------------------------------------------------------------------------
# Generated for Chili!Soft ASP Server
#
# Author: Chili!Soft, Inc. (2000)
# Script: <<reboot::script_name>>
#------------------------------------------------------------------------------

. /etc/rc.config

# Set this to something other than yes to disable automatic restart on system
# boot.  If it is set to something other than yes, the script will only 
# execute if run by a user (ie. not during runlevel changes).
START_ASP=yes

# Determine the base and follow a runlevel link name.
base=${0##*/}
link=${base#*[SK][0-9][0-9]}

# Force execution if not called by a runlevel directory.
test $link = $base && START_ASP_=yes
test "$START_ASP" = yes || exit 0

# The echo return value for success (defined in /etc/rc.config).
return=$rc_done
case "$1" in
    start)
        echo -n "Executing start script (<<reboot::script_name>>): "
	<<reboot::start_script>> > /dev/null 2>&1 || return=$rc_failed
        echo -e "$return"

        touch /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
    stop)
        echo -n "Executing stop script (<<reboot::script_name>>): "
	<<reboot::stop_script>> > /dev/null 2>&1 || return=$rc_failed
        echo -e "$return"

        rm -f /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
    restart)
        $0 stop || return=$rc_failed
        $0 start || return=$rc_failed
        ;;
    status)
        echo "Executing status script(<<reboot::script_name>>): "
	<<reboot::status_script>>
        ;;
    *)
        echo "Usage: $0 {start|stop|status|restart}"
        exit 1
        ;;
esac

# Inform the caller not only verbosely and set an exit status.
test "$return" = "$rc_done" || exit 1
exit 0
';

$Slackware_RCFile = 
'#! /bin/sh
#------------------------------------------------------------------------------
# Generated for Chili!Soft ASP Server
#
# Author: Chili!Soft, Inc. (2000)
# Script: <<reboot::script_name>>
#------------------------------------------------------------------------------

rc_success="Success."
rc_failed="Failure."

return=$rc_success
case "$1" in
    start)
        echo -n "Executing start script (<<reboot::script_name>>): "
	<<reboot::start_script>> > /dev/null 2>&1 || return=$rc_failed
        echo -e "$return"

        touch /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
    stop)
        echo -n "Executing stop script (<<reboot::script_name>>): "
	<<reboot::stop_script>> > /dev/null 2>&1 || return=$rc_failed
        echo -e "$return"

        rm -f /var/lock/subsys/<<reboot::script_name>> > /dev/null 2>&1
        ;;
    restart)
        $0 stop || return=$rc_failed
        $0 start || return=$rc_failed
        ;;
    status)
        echo "Executing status script(<<reboot::script_name>>): "
	<<reboot::status_script>>
        ;;
    *)
        echo "Usage: $0 {start|stop|status|restart}"
        exit 1
        ;;
esac

# Inform the caller not only verbosely and set an exit status.
test "$return" = "$rc_success" || exit 1
exit 0
';

$Debian_RCFile = $Slackware_RCFile;

#########################
# Solaris 
#########################
$SunOS_RCFile = $Slackware_RCFile;
	
#########################
# AIX 
#########################
$AIX_RCFile =
'#!/usr/bin/ksh
#------------------------------------------------------------------------------
# Generated for Chili!Soft ASP Server
#
# Author: Chili!Soft, Inc. (2000)
# Script: <<reboot::script_name>>

# NOTE: To avoid your system from failing on reboot, do not change this
#       file in any way.
# This script is designed to be executed on reboot.
#
#############################################################################
#------------------------------------------------------------------------------

rc_success="Success."
rc_failed="Failure."

return=$rc_success
# See how we were called.
case "$1" in
  start)
        echo "Executing start script (<<reboot::script_name>>): \c"
        <<reboot::start_script>> > /dev/null 2>&1 || return=$rc_failed
        echo "$return"
        ;;
  stop)
        echo "Executing stop script (<<reboot::script_name>>): \c"
        <<reboot::stop_script>> > /dev/null 2>&1 || return=$rc_failed
        echo "$return"
        ;;
  status)
        echo "Executing status script(<<reboot::script_name>>): "
        <<reboot::status_script>>
        ;;
  restart)
        $0 stop
        $0 start
        ;;
  *)
        echo "Usage: $0 {start|stop|restart|status}"
        exit 1
esac

# Inform the caller not only verbosely and set an exit status.
test "$return" = "$rc_success" || exit 1
exit 0
';   

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# External functions
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#------------------------------------------------------------------------------
# This method returns non-undef / true in the case of automatic reboot being
# enabled for the running distribution.
#------------------------------------------------------------------------------
sub supported {
  # Invoke the appropriate install_script function for the appropriate OS, 
  # distribution, etc. using the following rules:
  #  If a function exists by the name install_<OS>_<Distribution Name>, use that function, else
  #    If a function exists by the name install_<OS>_<Distribution Flavor>, use that function, else
  #      If a function exists by the name install_<OS>_Default, use that function, else
  #        return(undef)

  # Note: supported requires both an install and an uninstall function.

  my $base_install = "install_$pOS->{os}_";
  my $base_uninstall = "uninstall_$pOS->{os}_";
  my @attempts = ($pOS->{distribution},$pOS->{distribution_flavor},"Default");

  foreach(@attempts) {
    my $install = "$base_install$_";
    my $uninstall = "$base_uninstall$_";

    if ((defined &$install) && (defined &$uninstall)) {
      return(1);
    }
  }

  #---------------------------------------------------------------------------
  # Non-supported platform / distribution.
  #---------------------------------------------------------------------------  
  return(undef);
}

sub retrieve_RCFile
{
  ($#_ < 0) || die "Invalid number of arguments.";

  my $RCFile_Distribution_Var = "$pOS->{distribution}_RCFile";
  my $RCFile_Flavor_Var = "$pOS->{distribution_flavor}_RCFile";
  my $RCFile_OS_Var = "$pOS->{os}_RCFile";

  my $RCFile;

  if (defined $$RCFile_Distribution_Var) {
    # If there is a specific variant of the RedHat RCFile that we want to use 
    # for a given RedHat flavor, it will have an associated RCFile.
    # Use it if there is one.

    $RCFile = $$RCFile_Distribution_Var;
  }
  elsif (defined $$RCFile_Flavor_Var) {
    $RCFile = $$RCFile_Flavor_Var;
  }
  elsif (defined $$RCFile_OS_Var) {
    $RCFile = $$RCFile_OS_Var;
  }
  else {
    if ($pOS->{os} =~ /Linux/i) {
      die "Unable to locate RCFile for distribution / flavor ($pOS->{distribution}/$pOS->{distribution_flavor}).";
    }
    else {
      die "Unable to locate RCFile for $pOS->{os}.";
    }
  }

  return($RCFile);
}

#------------------------------------------------------------------------------
# RedHat
#------------------------------------------------------------------------------
sub install_Linux_RedHat
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );
  
  my $script_path = "/etc/rc.d/init.d/$script_name";
  my $RCFile = retrieve_RCFile;
    
  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  my $source = "../init.d/$script_name";
  
  # Generate start links.
  foreach (3 .. 5) {
    my $destination = "/etc/rc.d/rc$_.d/S$start_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }
  
  # Generate kill links.
  foreach (0, 1, 2, 6) {
    my $destination = "/etc/rc.d/rc$_.d/K$stop_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }    
  
  return(1);
}

sub uninstall_Linux_RedHat
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;
  
  if ($pOS->{distribution_flavor} eq "RedHat") {
    unlink("/etc/rc.d/init.d/$script_name");
    
    foreach (0 .. 6) {
      unlink("/etc/rc.d/rc$_.d/K$stop_priority$script_name");
      unlink("/etc/rc.d/rc$_.d/S$start_priority$script_name");
    }
    
    return(1);
  }
}

#------------------------------------------------------------------------------
# SuSE
#------------------------------------------------------------------------------
sub install_Linux_SuSE
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );
  
  my $script_path = "/sbin/init.d/$script_name";
  my $RCFile = retrieve_RCFile;
  
  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  unless(symlink($script_path,"/sbin/rc$script_name")) {
    uninstall_script($script_name,$start_priority,$stop_priority);
    return(error("Unable to make symlink from $script_path to /sbin/rc$script_name"));
  }
  
  my $source = "../$script_name";
  
  # Generate start links.
  foreach (2 .. 5) {
    my $destination = "/etc/rc.d/rc$_.d/S$start_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }
  
  # Generate kill links.
  foreach (0, 1, 6) {
    my $destination = "/etc/rc.d/rc$_.d/K$stop_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }    
  
  return(1);
}

sub uninstall_Linux_SuSE
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;

  unlink("/sbin/init.d/$script_name");
  unlink("/sbin/rc$script_name");
  
  foreach (0 .. 6) {
    unlink("/etc/rc.d/rc$_.d/K$stop_priority$script_name");
    unlink("/etc/rc.d/rc$_.d/S$start_priority$script_name");
  }
  
  return(1);
}

#------------------------------------------------------------------------------
# Slackware
#------------------------------------------------------------------------------
sub install_Linux_Slackware
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );

  ### Even though Slackware uses BSD-style init scripts still, they have 
  ### made SysV-style init scripts available through one BSD-style script
  ### which is responsible for checking the existence of any SysV-style 
  ### scripts and executing them (rc.sysvinit).
  
  my $script_dir = "/etc/rc.d/init.d";
  
  if (not -d $script_dir) {
    unless(mkdir($script_dir,0750)) {
      return(error("Unable to create $script_dir for SysV-style init scripts."));
    }
  }
  
  my $script_path = "$script_dir/$script_name";
  my $RCFile = retrieve_RCFile;
  
  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  my $source = "../init.d/$script_name";
  
  # Generate start links.
  foreach (2 .. 5) {
    my $destination_dir = "/etc/rc.d/rc$_.d";
    
    if (not -d $destination_dir) {
      unless(mkdir($destination_dir,0750)) {
	uninstall_script($script_name,$start_priority,$stop_priority);
	return(error("Unable to create directory $destination_dir for SysV-style init script."));
      }
    }
    
    my $destination = "$destination_dir/S$start_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }
  
  # Generate kill links.
  foreach (0, 1, 6) {
    my $destination_dir = "/etc/rc.d/rc$_.d";
    
    if (not -d $destination_dir) {
      unless(mkdir($destination_dir,0750)) {
	uninstall_script($script_name,$start_priority,$stop_priority);
	return(error("Unable to create directory $destination_dir for SysV-style init script."));
      }
    }
    
    my $destination = "$destination_dir/K$stop_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }    
  
  return(1);
}

sub uninstall_Linux_Slackware
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;

  unlink("/etc/rc.d/init.d/$script_name");
  
  foreach (0 .. 6) {
    unlink("/etc/rc.d/rc$_.d/K$stop_priority$script_name");
    unlink("/etc/rc.d/rc$_.d/S$start_priority$script_name");
  }
  
  return(1);
}

#------------------------------------------------------------------------------
# Debian
#------------------------------------------------------------------------------
sub install_Linux_Debian
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );
  
  my $script_path = "/etc/init.d/$script_name";
  my $RCFile = retrieve_RCFile;

  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  my $source = "../init.d/$script_name";
  
  # Generate start links.
  foreach (2 .. 5) {
    my $destination = "/etc/rc$_.d/S$start_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }
  
  # Generate kill links.
  foreach (0, 1, 6) {
    my $destination = "/etc/rc$_.d/K$stop_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }    
  
  return(1);
}

sub uninstall_Linux_Debian
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;
  
  if ($pOS->{distribution_flavor} eq "Debian") {
    unlink("/etc/init.d/$script_name");
    
    foreach (0 .. 6) {
      unlink("/etc/rc$_.d/K$stop_priority$script_name");
      unlink("/etc/rc$_.d/S$start_priority$script_name");
    }
    
    return(1);
  }
}

#------------------------------------------------------------------------------
# SunOS
#------------------------------------------------------------------------------
sub install_SunOS_Default
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );
  
  my $script_dir = "/etc/init.d";

  if (not -d $script_dir) {
    INSTALL::common::mkpath($script_dir) || return(error("Unable to create reboot path $script_dir"));
  }
  
  my $script_path = "$script_dir/$script_name";
  my $RCFile = retrieve_RCFile;

  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  my $source = "../init.d/$script_name";
  
  # Generate start links.
  foreach (2) {
    my $destination = "/etc/rc$_.d/S$start_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }
  
  # Generate kill links.
  foreach (0, 1, 6) {
    my $destination = "/etc/rc$_.d/K$stop_priority$script_name";
    
    unlink($destination);
    unless(symlink($source,$destination)) {
      uninstall_script($script_name,$start_priority,$stop_priority);
      return(error("Unable to make symlink from $source to $destination.\n"));
    }
  }    
  
  return(1);
}

sub uninstall_SunOS_Default
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;
  
  unlink("/etc/init.d/$script_name");
  
  foreach (0 .. 6) {
    unlink("/etc/rc$_.d/K$stop_priority$script_name");
    unlink("/etc/rc$_.d/S$start_priority$script_name");
  }
  
  return(1);
}

#------------------------------------------------------------------------------
# AIX
#------------------------------------------------------------------------------
sub install_AIX_Default
{
  ($#_ == 5) || die "Invalid number of arguments.";
  
  my ($script_name, $start_script, $stop_script, $status_script, $start_priority, $stop_priority) = @_;
  my %substitute = 
    (
     reboot::script_name => $script_name,
     reboot::start_script => $start_script,
     reboot::stop_script => $stop_script,
     reboot::status_script => $status_script,
     reboot::start_priority => $start_priority,
     reboot::stop_priority => $stop_priority
    );

  # we need to generate a /etc/rc.XX script .
  my $script_path = "/etc/rc.$script_name";
  my $RCFile = retrieve_RCFile;
  
  unlink($script_path);
  INSTALL::substitute::string_to_file
    ({ map { ("<<$_>>" => $substitute{$_}) } keys %substitute },
     $script_path,
     $RCFile
    );
  
  chmod(0750,$script_path);
  
  my @reboot_tags;
  
  if (-x "/usr/sbin/lsitab") {
    @reboot_tags = grep { m@^chiliasp-[0-9]+:[^:]*:[^:]*:/etc/rc.$script_name start@ } split(/\n/,`/usr/sbin/lsitab -a`);
  }
  else {
    unless(open(INITTAB,"</etc/inittab")) 
    {
      return(error("Unable to open the /etc/inittab file. Chili!Asp is not configured to be started after a reboot.\n"));
    }
    else {
      @reboot_tags = grep { m@^chiliasp-[0-9]+:[^:]*:[^:]*:/etc/rc.$script_name start@ } <INITTAB>;
      close(INITTAB);
    }
  }
  
  my $reboot_tag = $reboot_tags[0];
  my $default_runlevel;
  my $entry_exists = 0;
  
  $reboot_tag =~ s/^([^:]+):.*/$1/;
  
  open(INITTAB,"</etc/inittab") || die "Unable to open /etc/inittab for reading.";
  
  while(<INITTAB>) {
    if (/([0-9]):initdefault/) {
      $default_runlevel = $1;
    }
    if (/^$reboot_tag:(.*)/i) {
      $entry_exists = 1;
    }
  }
  
  close(INITTAB);
  
  if ($entry_exists) {
    system("/usr/sbin/rmitab \"$reboot_tag\"");
  }
  
  # auto-modifier of the /etc/inittab script found.
  if (system("/usr/sbin/mkitab \"$reboot_tag:$default_runlevel:once:$script_path start > /dev/console 2>&1\" ")) {
    error("\n mkitab command failed to update the /etc/inittab file. Chili!Asp is not configured to be started after a reboot.");
    report("Trying to manually modify the /etc/inittab file \n");
    
    my $dupname = "/etc/inittab.chiliasp-install";
    unlink($dupname);
    system("/bin/cp /etc/inittab $dupname");
    unless(open(SRC,"<$dupname") && open(INITTAB,">/etc/inittab")) 
    {
      # Back out any changes.
      close(SRC);
      close(INITTAB);
      unlink($dupname);
      unlink($script_path);
      return(error("Unable to open the /etc/inittab file. Chili!Asp is not configured to be started after a reboot.\n"));
    }
    my $last_line;
    my $entry_exists = 0;
    while (<SRC>)
    {
      $last_line = $_;
      print INITTAB if ((!/^$reboot_tag/i));
    }
    
    if (not chomp $last_line) {
      print INITTAB "\n";
    }
    
    print INITTAB "$reboot_tag:$default_runlevel:once:$script_path start > /dev/console 2>&1";
    close(SRC);
    close(INITTAB);
    unlink($dupname);
    report("Manual modification successfully completed.\n");
  }
  return(1);
}

sub uninstall_AIX_Default
{
  ($#_ == 2) || die "Invalid number of arguments.";
  
  my ($script_name,$start_priority, $stop_priority) = @_;

  my @reboot_ids;
  
  if (-x "/usr/sbin/lsitab") {
    @reboot_ids = 
      map{ m@chiliasp-([0-9]+)@; $1 } grep { m@^chiliasp-[0-9]+@ } split(/\n/,`/usr/sbin/lsitab -a`);
  }
  else {
    unless(open(INITTAB,"</etc/inittab")) 
    {
      return(error("Unable to open the /etc/inittab file. Chili!Asp is not configured to be started after a reboot.\n"));
    }
    else {
      @reboot_ids = 
	map{ m@chiliasp-([0-9]+)@; $1 } grep { m@^chiliasp-[0-9]+@ } <INITTAB>;
      close(INITTAB);
    }
  }
  
  my $reboot_id = 0;
  foreach(sort { $a <=> $b } @reboot_ids) {
    my $id = $_;
    
    if ($id <= $reboot_id) {
      $reboot_id++;
    }
    else {
      last;
    }
  }
  
  my $reboot_tag = sprintf("chiliasp-%03d",$reboot_id);
  
  # remove the script and modify the inittab file.
  unlink("/etc/rc.$script_name");
  
  if (system("/usr/sbin/rmitab \"$reboot_tag\"")) {
    report ("rmitab failed to remove the entry $reboot_tag");
    report("Trying to manually modify the /etc/inittab file \n");
    
    my $dupname = "/etc/inittab.chiliasp-install";
    unlink($dupname);
    system("/bin/cp /etc/inittab $dupname");
    unless(open(SRC,"<$dupname") && open(INITTAB,">/etc/inittab")) 
    {
      # Back out any changes.
      close(SRC);
      close(INITTAB);
      unlink($dupname);
      report("Unable to open the /etc/inittab file.\n");
      report("You will have to manually remove the line corresponding to the entry - $reboot_tag from the /etc/inittab file");
      report ("Press any key to continue \n");
      <STDIN>;
      return 0;
    }
    while (<SRC>)
    {
      print INITTAB if ((! /^$reboot_tag:/i));
    }
    close(SRC);
    close(INITTAB);
    unlink($dupname);
    report("Manual modification successfully completed.\n");
  }
  return(1);
}

#==============================================================================
#------------------------------------------------------------------------------
####################################################### User-accessible scripts
#------------------------------------------------------------------------------
#==============================================================================

sub install_script 
{
  # Invoke the appropriate install_script function for the appropriate OS, 
  # distribution, etc. using the following rules:
  #  If a function exists by the name install_<OS>_<Distribution Name>, use that function, else
  #    If a function exists by the name install_<OS>_<Distribution Flavor>, use that function, else
  #      If a function exists by the name install_<OS>_Default, use that function, else
  #        return(undef)

  my $base_function = "install_$pOS->{os}_";
  my @attempts = ($pOS->{distribution},$pOS->{distribution_flavor},"Default");

  foreach(@attempts) {
    my $function = "$base_function$_";

    if (defined &$function) {
      return(&$function(@_));
    }
  }

  #---------------------------------------------------------------------------
  # Non-supported platform / distribution.
  #---------------------------------------------------------------------------  
  return(undef);
}

sub uninstall_script
{
  # Invoke the appropriate install_script function for the appropriate OS, 
  # distribution, etc. using the following rules:
  #  If a function exists by the name install_<OS>_<Distribution Name>, use that function, else
  #    If a function exists by the name install_<OS>_<Distribution Flavor>, use that function, else
  #      If a function exists by the name install_<OS>_Default, use that function, else
  #        return(undef)

  my $base_function = "uninstall_$pOS->{os}_";
  my @attempts = ($pOS->{distribution},$pOS->{distribution_flavor},"Default");

  foreach(@attempts) {
    my $function = "$base_function$_";

    if (defined &$function) {
      return(&$function(@_));
    }
  }

  #---------------------------------------------------------------------------
  # Non-supported platform / distribution.
  #---------------------------------------------------------------------------  
  return(undef);
}

1;
