# function which can store your present path.
function save 
{
 MYLIBPATH=$LIBPATH
 MYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
 MYSHLIB_PATH=$SHLIB_PATH
 MYPATH=$PATH
}

# function which would restore your present path.
function restore
{
  if [ -z "$LIBPATH" ]; then
    LIBPATH=$MYLIBPATH
  else
    LIBPATH=$LIBPATH:$MYLIBPATH
  fi
  if [ -z "$LD_LIBRARY_PATH" ]; then
    LD_LIBRARY_PATH=$MYLD_LIBRARY_PATH
  else
    LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$MYLD_LIBRARY_PATH
  fi
  if [ -z "$SHLIB_PATH" ]; then
    SHLIB_PATH=$MYSHLIB_PATH
  else
    SHLIB_PATH=$SHLIB_PATH:$MYSHLIB_PATH
  fi
  if [ -z "$PATH" ]; then
    PATH=$MYPATH
  else
    PATH=$PATH:$MYPATH
  fi
  export PATH LIBPATH SHLIB_PATH LD_LIBRARY_PATH 
}

if [ "$#" -ne 1 ]; then
  echo "this script cannot be called with more than one parameters"
else
  # you will need to verify whether you have a valid file name here, before
  # sourcing this.
  if [ "x$1" != "x" ] && [ -f "$1" ];then
    save
    OLD_PWD=$PWD
    NEW_PWD=`echo $1 | sed 's,^\(.*\)/[^/]*$,\1,'`
    cd $NEW_PWD
    . "$1"
    cd $OLD_PWD
    restore
  fi
fi
