<% 
const c_DriversDSN = "DSN=DRIVERS;"
const c_DSNTestFile = "dsntest"
const c_NoPassword = "P-A-S-S-W-O-R-D"

' Constants for ODBC tab
const c_tabDSN = 1
const c_tabDrv = 2
const c_tabConnPool = 3
const c_tabDBEnvVar = 4
const c_tabDB2Pf = 5

' Constants for DB Engines
const c_PostgreSQL = 1
const c_MySQL = 2
const c_SequeLink = 3
const c_dBASE = 4
const c_Oracle = 5
const c_MSSQL = 6
const c_Sybase = 7
const c_Informix = 8
const c_DB2 = 9
const c_OpenIngres = 10
const c_InterBase = 11

const c_idxControl = 0
const c_idxValue = 1
const c_idxFldSize = 2

const c_TemplateID = "_template"

' Constants for DB2 profile files
Const strPfFileName = "/db2setup.sh"
Const cstrSourceCmd = "/INSTALL/db2loadprofile.sh"
Const cstrDB2DrvVar = "target="

' FileSystem file open constants
Const ForReading = 1, ForWriting = 2, ForAppending = 8

function ODBCTab( ActiveTab )
	WriteTab "Data Source Names", "odbc/odbc.dsn.asp?srv=" & strServerURL & "&sname=" & strSNameURL, "Add/Edit/Remove Data Source Names", c_tabDSN=ActiveTab
	WriteTab "Drivers", "odbc/odbc.drv.asp?srv=" & strServerURL & "&sname=" & strSNameURL, "List supported ODBC Drivers", c_tabDrv=ActiveTab
	WriteTab "ADO Settings", "odbc/odbc.pool.asp?srv=" & strServerURL & "&sname=" & strSNameURL, "ADO Settings", c_tabConnPool=ActiveTab
	WriteTab "Environment", "odbc/odbc.env.asp?srv=" & strServerURL & "&sname=" & strSNameURL, "Environment", c_tabDBEnvVar=ActiveTab
	WriteTab "DB2 Profiles", "odbc/odbc.db2pf.asp?srv=" & strServerURL & "&sname=" & strSNameURL, "DB2 Profiles", c_tabDB2Pf=ActiveTab
end function

Dim g_ODBCActiveTab

Function SetODBCINIFile( strINIFile, oSectionDSNs )
Dim oINIFile
	Set oINIFile = Server.CreateObject("chili.inifile")
	on error resume next
	oINIFile.Open strINIFile
	Set oSectionDSNs = oINIFile.Sections("ODBC Data Sources")
	if( 0<>Err.number )Then
		ErrMsg( Err.description )
	end if
	on error goto 0
	Set SetODBCINIFile = oINIFile
end Function

function SupportedEnginesSQL ( strOSKey )

	SupportedEnginesSQL = "SELECT ENGOS.ID, EngOS.ENGID, EngOS.OSID, TRIM(e.Name) AS NAME, IIF(TRIM(e.Version)='_', '', TRIM(e.Version)) AS VERSION " & _
		"FROM ENGOS, OS, ENGINES e " & _
		"WHERE (OS.KEY='" & UCase(strOSKey) & "' AND OS.ID=EngOS.OSID AND e.ID=EngOS.ENGID) " & _
		"ORDER BY EngOS.ENGID"
	
end function


function SupportedDriversSQL ( iEngOSID )

	SupportedDriversSQL = "SELECT DRVENGOS.ID, DRVENGOS.DRVID, TRIM(DRIVERS.FileName) AS FileName, IIF(TRIM(DRIVERS.Version)='_', '', TRIM(DRIVERS.Version)) AS VERSION, TRIM(DRIVERS.Notes) AS Notes " & _
		"FROM DRVENGOS, DRIVERS " & _
		"WHERE (DRVENGOS.ENGOSID=" & iEngOSID & " AND DRIVERS.ID=DRVENGOS.DRVID) " & _
		"ORDER BY DRVENGOS.ENGOSID"
	
end function

function AllDriversPerOSSQL ( strOSKey )

	AllDriversPerOSSQL = "SELECT e.ID AS ENGID, TRIM(e.Name) AS ENGNAME, IIF(TRIM(e.Version)='_', '', TRIM(e.Version)) AS ENGVER, " & _
			"TRIM(d.FileName) AS DRVFILE, IIF(TRIM(d.Version)='_', '', TRIM(d.Version)) AS DRVVER, TRIM(d.Notes) AS DRVNOTES, " & _
			"TRIM(dl.DRVLOCAT) AS DRVLOCAT " & _
		"FROM ENGOS eo, OS o, ENGINES e, DRIVERS d, DRVENGOS deo, DRVLOCAT dl " & _
		"WHERE (o.KEY='" & UCase(strOSKey) & "' AND eo.OSID=O.ID AND " & _
			"eo.ENGID=e.ID AND deo.ENGOSID=eo.ID AND d.ID=deo.DRVID AND dl.ID=deo.DRVLOCID) " & _
		"ORDER BY eo.ENGID"
	
end function

function AttributesSQL ( iDRVENGOSID )

	AttributesSQL = "SELECT a.ACSUPP, a.ID, TRIM(a.FRNAME) AS FRNAME, a.SHOWUI, TRIM(a.Name) AS Name, TRIM(a.Default) AS Default, " & _
			"TRIM(i.KEY) AS Control, a.ENGID, " & _
			"TRIM(d.FILENAME) AS FILENAME, TRIM(e.NAME) AS ENGNAME, TRIM(dl.DRVLOCAT) AS DRVLOCAT, " & _
			"TRIM(a.REGEXPR) AS RegExpr, TRIM(a.VALIDMSG) AS ValidMsg, a.FIELDLEN " & _  
		"FROM ATTS a, INPUTS i, DRVENGOS deo, DRIVERS d, ENGINES e, DRVLOCAT dl " & _
		"WHERE (deo.ID=" & iDRVENGOSID & " AND d.ID=deo.DRVID AND a.ENGID=d.ENGID AND " & _
			"a.INPUTID=i.ID AND e.ID=a.ENGID AND dl.ID=deo.DRVLOCID AND a.ACSUPP<>0) " & _
		"ORDER BY a.INDEX ASC"
	
end function


function DriverAttribsSQL ( strDriver )
	DriverAttribsSQL = "SELECT D.ID, TRIM(D.FILENAME) AS FILENAME, IIF(TRIM(D.Version)='_', '', TRIM(D.Version)) AS DRVVER, A.ENGID, " & _
					"TRIM(A.NAME) AS ATTNAME, TRIM(I.KEY) AS CONTROL, TRIM(A.REGEXPR) AS REGEXPR, " & _
					"TRIM(A.VALIDMSG) AS VALIDMSG, TRIM(A.DEFAULT) AS DEFAULT, A.SHOWUI, TRIM(E.NAME) AS ENGNAME, " & _
					"IIF(TRIM(E.Version)='_', '', TRIM(E.Version)) AS ENGVER, A.FIELDLEN AS FIELDLEN " & _
					"FROM DRIVERS D, INPUTS I, ATTS A, ENGINES E " & _
					"WHERE D.FILENAME='" & strDriver & "' AND D.ENGID=E.ID AND E.ID=A.ENGID AND I.ID=A.INPUTID " & _
					"ORDER BY D.ID, A.ENGID, A.INDEX"
end function

function DriverEngineSQL ( )
	DriverEngineSQL = "SELECT D.ID, D.ENGID, TRIM(D.FILENAME) AS FILENAME, IIF(TRIM(d.Version)='_', '', TRIM(d.Version)) AS DRVVER, " & _
					"TRIM(E.NAME) AS ENGNAME, " & _
					"IIF(TRIM(E.Version)='_', '', TRIM(E.Version)) AS ENGVER " & _
					"FROM DRIVERS D, ENGINES E " & _
					"WHERE D.ENGID=E.ID " & _
					"ORDER BY D.ID"
end function

' Creates Array and Dictionary object from DNS section from ODBC.INI and Recordset from the DNS system database
'
Function MergeDSNAtts( rsDrvProps, oSection, oDict, PasswordIndex )
	Dim arDict(), nIndex, oKeyPear, strTemp2, iSize
	
	PasswordIndex = -1
									
	Set oDict = Server.CreateObject("Scripting.Dictionary")
									
	oDict.CompareMode = 1
	
	if( not IsEmpty(oSection) )Then
		if( oSection.Items.Count<3 )Then
			ReDim arDict(2)
		else
			ReDim arDict(oSection.Items.Count-1)
		end if
	else
		ReDim arDict(2)
	end if
	
	arDict(0)="Description"
	oDict.Add arDict(0), Array( "TEXT", "", c_DefTextFieldLen )
	arDict(1)="Driver"
	oDict.Add arDict(1), Array( "TEXT", "", c_DefTextFieldLen )
	
	nIndex=2
	rsDrvProps.MoveFirst
	do while not rsDrvProps.EOF
		arDict(nIndex) = rsDrvProps("ATTNAME").Value
		oDict.Add arDict(nIndex), Array( rsDrvProps("CONTROL").Value, _
			rsDrvProps("DEFAULT").Value, _
			iif( IsNull(rsDrvProps("FIELDLEN").Value), c_DefTextFieldLen, rsDrvProps("FIELDLEN").Value) )
		
		if( "PASSWORD"=rsDrvProps("CONTROL").Value )Then PasswordIndex = nIndex
		
		rsDrvProps.MoveNext
		nIndex = nIndex + 1
		if( nIndex>UBound(arDict) )Then
			ReDim Preserve arDict( UBound(arDict)+UBound(arDict)\2 )
		end if
	loop
	
	if( not IsEmpty(oSection) )Then	
		for each oKeyPear in oSection.Items
			if( not oDict.Exists(oKeyPear.Key) )Then
				arDict(nIndex) = oKeyPear.Key
				strTemp2 = "TEXT"
				iSize = c_DefTextFieldLen
				nIndex = nIndex + 1
				if( nIndex>UBound(arDict) )Then
					ReDim Preserve arDict( UBound(arDict)+UBound(arDict)\2 )
				end if
			else
				strTemp2 = oDict.Item(oKeyPear.Key)(c_idxControl)
				iSize = oDict.Item(oKeyPear.Key)(c_idxFldSize)
			end if
			oDict.Item(oKeyPear.Key)=Array( strTemp2, oKeyPear.Value, iSize )
		next
	end if
	
	nIndex=nIndex-1
	if( nIndex<UBound(arDict) )Then
		ReDim Preserve arDict( nIndex )
	end if

	MergeDSNAtts = arDict
									
end function


%>