
function LoadDB2 
{
  # DB2 Setup.
  # To enable DB2 connectivity, we need to source the DB2 client's profile
  # file, which would set us the environment correctly. 
  # these list of profile file names are presently stored at a file 
  # called db2setup.sh
  if [ -f /home/chiliasp/db2setup.sh ]; then
    # source this file to setup the DB2 environment.
    . /home/chiliasp/db2setup.sh
  fi
}

if [ -z "$LC_ALL" ] || [ -z "$LANG" ] || [ -z "$LANGUAGE" ]; then
  if [ -z "$LANG" ]; then
    if [ -r /etc/environment ]; then
      LANG=`/bin/cat /etc/environment | awk -F "=" '/LANG/ {print $2}'` 
    fi
  fi
  if [ -z "$LC_ALL" ]; then
    if [ -n "$LANG" ]; then
      LC_ALL="$LANG"
    elif [ -n "$LANGUAGE" ]; then
      LC_ALL="$LANGUAGE"
    elif [ -n "$LINGUAS" ]; then
      LC_ALL="$LINGUAS"
    else
      # Default to US English
      LC_ALL="en_US"
    fi
  fi
  if [ -z "$LANG" ]; then 
    LANG="$LC_ALL"
  fi
  if [ -z "$LANGUAGE" ]; then
    LANGUAGE="$LC_ALL"
  fi
  if [ -z "$LINGUAS" ]; then
    LINGUAS="$LC_ALL"
  fi
fi

# add MySQL client lib path here.
# this should be changed if MySQL had been installed in
# a different location
MYSQL_LIBPATH=/usr/local/lib/mysql

# this is the default home for SQL, which is shipped by Chili!Soft ASP.
SQLNK_HOME=/home/chiliasp/odbc/sqlnk/ini

new_libpath=/home/chiliasp/odbc/direct/lib:/home/chiliasp/odbc/sqlnk/lib:${MYSQL_LIBPATH}:/home/chiliasp/odbc/opensource/lib

if [ -z "${LD_LIBRARY_PATH}" ]; then
  LD_LIBRARY_PATH=${new_libpath}
else
  LD_LIBRARY_PATH=${new_libpath}:${LD_LIBRARY_PATH}
fi
			
if [ -z "$LIBPATH" ]; then
  LIBPATH=${new_libpath}
else
  LIBPATH=${new_libpath}:${LIBPATH}
fi

if [ -z "$SHLIB_PATH" ]; then
  SHLIB_PATH=${new_libpath}
else
  SHLIB_PATH=${new_libpath}:${SHLIB_PATH}
fi

export SQLNK_HOME
export LD_LIBRARY_PATH LIBPATH SHLIB_PATH

# Load DB2 if you have one.
LoadDB2 "$@"
# extras
