
# Main Program to install SpicePack Sample files and modify ASP configuration

($#_ < 1) || die "Invalid number of arguments to file.";

my ($package_dir,$asphome)=@ARGV;

if (! -d "$package_dir")  {
  print "This program needs a package directory to continue !";
  exit 1;
}
elsif (-d "$package_dir/package") {
  $package_dir = "$package_dir/package";
}

if (-d $asphome && -e $asphome) 
{
  #remove existing spicepack directory
  if (-e "$asphome/spicepack_samples")
  {
    system("rm -rf $asphome/spicepack_samples");
  }
  elsif (-e "$asphome/caspsamp/spicepack_samples")
  {
    system("rm -rf $asphome/caspsamp/spicepack_samples");
  }

  #copy files
  if (! -d "$asphome/caspsamp")
  {
    system("mkdir -p $asphome/caspsamp");
  }
  system("cp -r $package_dir/spicepack_samples $asphome/caspsamp");
  if (-d "$asphome/caspsamp/spicepack_samples/mail")
  {
    system("chmod 777 $asphome/caspsamp/spicepack_samples/mail");
  }

  #copy doc files
  if (! -d "$asphome/caspdoc")
  {
    system("mkdir -p $asphome/caspdoc");
  }
  if (! -d "$asphome/caspdoc/pdf")
  {
    system("mkdir -p $asphome/caspdoc/pdf");
  }
  system("cp -f $package_dir/spicepack.pdf $asphome/caspdoc/pdf");
  system("cp -f $package_dir/chili_mail_smtp_component_.htm $asphome/caspdoc/html/");
  system("cp -f $package_dir/installing_spicepack.htm $asphome/caspdoc/html/");
  if ( -f "$package_dir/spicepack_component_reference.htm") 
  {
    system("cp -f $package_dir/spicepack_component_reference.htm $asphome/caspdoc/html/");
  }
  if ( -f "$package_dir/spicepack_component_referen.htm") 
  {
    system("cp -f $package_dir/spicepack_component_referen.htm $asphome/caspdoc/html/spicepack_component_reference.htm");
  }
} 
else {
  print "ChiliAsp Installation Directory is not found ";
  exit 1;
}

my @aspdirs;
my $i = 0;
my $dir ;

#look in install_db for list of installed asp engines
open(INSTALL_DB, "$asphome/.installed_db");
foreach $dir (<INSTALL_DB>)
{
  if ($dir  =~ /^\[([^\]]*)\]$/)
  {
    @aspdirs[$i] = $1;
    $i++;
    last;
  }
}
close(INSTALL_DB);
foreach (@aspdirs)
{
  $readfile="$_/casp.cnfg.pre-spicepack";
  $writefile="$_/casp.cnfg";
  system("mv -f $writefile $readfile");
  open(READFILE, "< $readfile") ;
  open(WRITEFILE, "> $writefile") ;
  foreach (<READFILE>)
  {
    if ($_ =~ /^\/spicepack_samples=.*/) {
      next;
    }
    if ($_ =~ /^\/caspsamp=.*/)
    {
      print WRITEFILE "/spicepack_samples=\"$asphome/caspsamp/spicepack_samples\"\n";
    }
    print WRITEFILE $_;
  }
  close(WRITEFILE);
  close(READFILE);
  unlink($readfile);
}
exit 0;
